<script setup lang="ts">
import { useCounterMixin } from "@/stores/mixin";
import { useQuasar, type QTableProps } from "quasar";
import { ref, onMounted } from "vue";

import http from "@/plugins/http";
import config from "@/app.config";
import { useDataStore } from "@/stores/data";

import type { DutyFormType } from "@/modules/10_registry/interface/index/Main";
//history dialog
import DialogHistory from "@/modules/10_registry/Dialog/DialogHistory.vue";

const link = ref<string>("");
const dataStore = useDataStore();
const idByRow = ref<string>("");
const rows = ref<DutyFormType[]>([]);
const rowsData = ref<DutyFormType[]>([]);
const filter = ref<string>("");
const rowsHistory = ref<DutyFormType[]>([]);
const rowsHistoryData = ref<DutyFormType[]>([]);
const $q = useQuasar();
const mode = ref<any>($q.screen.gt.xs);
const mixin = useCounterMixin();
const { showLoader, hideLoader, messageError, date2Thai, onSearchDataTable } =
  mixin;

const modalHistory = ref<boolean>(false);
/** ตัวแปรข้อมูล */

const visibleColumns = ref<string[]>([
  "commandName",
  "agency",
  "dateStart",
  "dateEnd",
  "commandNo",
  "document",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "commandName",
    align: "left",
    label: "ประเภทคำสั่ง",
    sortable: true,
    field: "commandName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "agency",
    align: "left",
    label: "หน่วยงานที่ให้ช่วยราชการ/ส่งตัวกลับ",
    sortable: true,
    field: "agency",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateStart",
    align: "left",
    label: "วันเริ่มช่วยราชการ",
    sortable: true,
    field: "dateStart",
    format: (v) => date2Thai(v),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateEnd",
    align: "left",
    label: "วันสิ้นสุดการช่วยราชการ",
    sortable: true,
    field: "dateEnd",
    format: (v) => date2Thai(v),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "commandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "commandNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "document",
    align: "left",
    label: "เอกสารอ้างอิง",
    sortable: true,
    field: "document",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    format: (v) => date2Thai(v, false, true),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const pagination = ref({
  sortBy: "lastUpdatedAt",
});

const visibleColumnsHistory = ref<string[]>([
  "commandName",
  "agency",
  "dateStart",
  "dateEnd",
  "commandNo",
  "document",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);
const columnsHistory = ref<QTableProps["columns"]>([
  {
    name: "commandName",
    align: "left",
    label: "ประเภทคำสั่ง",
    sortable: true,
    field: "commandName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "agency",
    align: "left",
    label: "หน่วยงานที่ให้ช่วยราชการ/ส่งตัวกลับ",
    sortable: true,
    field: "agency",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateStart",
    align: "left",
    label: "วันเริ่มช่วยราชการ",
    sortable: true,
    field: "dateStart",
    format: (v) => date2Thai(v),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateEnd",
    align: "left",
    label: "วันสิ้นสุดการช่วยราชการ",
    sortable: true,
    field: "dateEnd",
    format: (v) => date2Thai(v),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "commandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "commandNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "document",
    align: "left",
    label: "เอกสารอ้างอิง",
    sortable: true,
    field: "document",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    format: (v) => date2Thai(v, false, true),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);

function onHistory(id: string) {
  modalHistory.value = true;
  idByRow.value = id;
}

/** get data */
function getData() {
  showLoader();
  http
    .get(config.API.dataUserAssistanceByType(link.value))
    .then((res) => {
      const data = res.data.result;
      rows.value = data;
      rowsData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/** get history */
function getHistory() {
  showLoader();
  http
    .get(config.API.dataUserAssistanceHistoryByType(link.value, idByRow.value))
    .then((res) => {
      const data = res.data.result;
      rowsHistory.value = data;
      rowsHistoryData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันโหลไฟลเอกสารหลักฐาน
 * @param id รายการที่ต้องการโหลด
 */
async function onDownloadFile(id: string, profileId: string) {
  showLoader();
  await http
    .get(
      config.API.subFileByFileName(
        "ทะเบียนประวัติ",
        "ช่วยราชการ",
        profileId,
        id,
        "เอกสารหลักฐาน"
      )
    )
    .then(async (res) => {
      const data = res.data;
      window.open(data.downloadUrl, "_blank");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

function onSearch() {
  rows.value = onSearchDataTable(
    filter.value,
    rowsData.value,
    columns.value ? columns.value : []
  );
}

onMounted(async () => {
  link.value = await dataStore.getProFileType();
  getData();
});
</script>
<template>
  <!-- v-if="mode" -->
  <div class="col-12">
    <q-toolbar class="q-px-none q-mt-md">
      <span class="text-blue-6 text-weight-bold text-body1">ช่วยราชการ</span>
      <q-space />
      <q-input
        v-if="mode"
        class="inputgreen"
        outlined
        dense
        v-model="filter"
        label="ค้นหา"
        style="max-width: 200px"
        @keydown.enter.prevent="onSearch"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-if="mode"
        class="q-ml-sm"
        dense
        multiple
        outlined
        emit-value
        map-options
        options-dense
        option-value="name"
        style="min-width: 140px"
        v-model="visibleColumns"
        :options="columns"
        :display-value="$q.lang.table.columns"
      />
    </q-toolbar>
    <d-table
      flat
      dense
      bordered
      virtual-scroll
      :rows="rows.length !== 0 ? rows : []"
      :columns="columns"
      :grid="!mode"
      :rows-per-page-options="[10, 25, 50, 100]"
      :visible-columns="visibleColumns"
      :virtual-scroll-sticky-size-start="48"
      v-model:pagination="pagination"
    >
      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            <span class="text-weight-medium">{{ col.label }}</span>
          </q-th>
          <q-th auto-width />
          <q-th auto-width />
        </q-tr>
      </template>

      <template v-if="mode" v-slot:body="props">
        <q-tr :props="props" class="cursor-pointer">
          <q-td v-for="(col, index) in props.cols" :key="col.name">
            <div v-if="col.name == 'no'">
              {{ props.rowIndex + 1 }}
            </div>
            <div v-else>
              {{ col.value ? col.value : "-" }}
            </div>
          </q-td>
          <q-td auto-width>
            <q-btn
              v-if="props.row.isUpload"
              flat
              dense
              round
              color="green"
              size="14px"
              icon="mdi-file-document-outline"
              @click="onDownloadFile(props.row.id, props.row.profileId)"
            >
              <q-tooltip>ดาวน์โหลด</q-tooltip>
            </q-btn>
          </q-td>

          <q-td auto-width>
            <q-btn
              color="info"
              flat
              dense
              round
              size="14px"
              icon="mdi-history"
              @click="onHistory(props.row.id)"
            >
              <q-tooltip>ประวัติแก้ไขรายการช่วยราชการ</q-tooltip>
            </q-btn>
          </q-td>
        </q-tr>
      </template>
      <template v-else v-slot:item="props">
        <div class="q-mb-xs col-xs-12 col-sm-6 col-md-4 col-lg-3">
          <q-card bordered flat>
            <q-list dense class="q-mt-lg relative-position">
              <div class="row absolute_button">
                <q-btn
                  flat
                  dense
                  round
                  size="14px"
                  color="green"
                  icon="mdi-file-document-outline"
                  v-if="props.row.isUpload"
                  @click="onDownloadFile(props.row.id, props.row.profileId)"
                >
                  <q-tooltip>ดาวน์โหลด</q-tooltip>
                </q-btn>
                <q-btn
                  icon="mdi-history"
                  color="info"
                  flat
                  dense
                  round
                  size="14px"
                  @click="onHistory(props.row.id)"
                >
                  <q-tooltip>ประวัติแก้ไขรายการช่วยราชการ</q-tooltip>
                </q-btn>
              </div>
              <q-item v-for="col in props.cols" :key="col.name">
                <q-item-section class="fix_top">
                  <q-item-label class="text-grey-6 text-weight-medium">{{
                    col.label
                  }}</q-item-label>
                </q-item-section>
                <q-item-section class="fix_top">
                  <q-item-label class="text-dark text-weight-medium">{{
                    col.value ? col.value : "-"
                  }}</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>
      </template>
    </d-table>
  </div>
  <DialogHistory
    v-model:modal="modalHistory"
    :title="'ประวัติแก้ไขรายการช่วยราชการ'"
    :getData="getHistory"
    :rows="rowsHistory"
    :rows-data="rowsHistoryData"
    :visibleColumns="visibleColumnsHistory"
    :columns="columnsHistory"
  />
</template>
<style scoped>
.absolute_button {
  position: absolute;
  right: 5px;
  top: -20px;
}

.fix_top {
  justify-content: start !important;
  margin-top: 10px;
}
</style>
